<?php
if (!class_exists('vBShop_Item_Core'))
{
	die('No direct access allowed.');
}

class vBShop_Item_forumdescription extends vBShop_Item_Core
{
	/**
	* The constructor
	*
	* @param	vBulletin	vBulletin registry
	* @param	array		Item info
	*/	
	public function __construct(&$registry, &$item)
	{
		$item['_nodeactivate'] = true;
		parent::__construct($registry, $item);
		
		// Set purchase template
		$this->config['purchasetemplate'] = 'dbtech_vbshop_configure_forumdescription';
	}
	
	/**
	* Function to call before every action
	*/	
	public function action()
	{
		if (!parent::action())
		{
			// This type is inactive
			return false;
		}
		
		// We made it!
		return true;
	}

	/**
	* Prints out an AdminCP form
	*/	
	public function print_admin_form($code)
	{
		global $vbphrase;
		
		print_yes_no_row($vbphrase['dbtech_vbshop_allow_forum_change'], 'item[code][allowchange]', 		$code['allowchange']);
		print_forum_chooser($vbphrase['dbtech_vbshop_excluded_forums'], 'item[code][excludedforums][]', $code['excludedforums'], NULL, true, true);
	}
	
	/**
	* Configure an item
	*
	* @param	integer		Purchase ID
	* @param	mixed		Recipient
	*/	
	public function configure($purchaseid, $recipient = null)
	{
		global $vbphrase;
		
		if (!$this->can_configure($purchaseid))
		{
			// Can't configure this item
			return false;
		}
		
		// Ensure this is set
		$recipient = (!$recipient ? $this->registry->userinfo : $recipient);
		
		// Get the form code
		$code 			= $this->registry->input->clean_gpc('p', 'code', 			TYPE_ARRAY);
		$noConfigure 	= $this->registry->input->clean_gpc('p', '_noConfigure', 	TYPE_BOOL);

		if ($noConfigure)
		{
			// We're done, we wanted to let the recipient configure it themselves
			return true;
		}
		
		if ($code['forumid'] AND $code['description'])
		{
			if (in_array($code['forumid'], $this->config['code']['excludedforums']))
			{
				// Excluded forum
				eval(standard_error(fetch_error('dbtech_vbshop_invalid_data', $vbphrase['forum'])));
			}	

			if ($this->config['configuration']['forumid'] != $code['forumid'] AND $this->config['configuration']['forumid'] AND !$this->config['code']['allowchange'])
			{
				// Excluded forum
				eval(standard_error(fetch_error('dbtech_vbshop_invalid_data', $vbphrase['forum'])));
			}

			$forumdata =& datamanager_init('Forum', $this->registry, ERRTYPE_SILENT);
				$forumdata->set_existing($this->registry->forumcache[$code['forumid']]);
				$forumdata->set('description', fetch_censored_text($code['description']));
			$forumdata->save();
		}
		
		if ($this->config['notifications_config'])
		{
			$userids = explode(',', $this->config['notifications_config']);
			foreach ((array)$userids as $userid)
			{
				// Send PM
				VBSHOP::sendPM(
					$userid,
					construct_phrase($vbphrase['dbtech_vbshop_new_configuration_x'],
						$this->config['title']
					),
					construct_phrase($vbphrase['dbtech_vbshop_x_just_configured_y'],
						$recipient['username'],
						$this->config['title'],
						$vbphrase['title'] . ': ' . ($this->registry->forumcache[$code['forumid']]['title']) . "\n" . 
							$vbphrase['description'] . ': ' . ($code['description'] ? $code['description'] : 'N/A')
					)
				);
			}
		}
		
		// Update flag
		$this->registry->db->query_write("
			UPDATE " . TABLE_PREFIX . "dbtech_vbshop_purchase
			SET configuration = " . $this->registry->db->sql_prepare(trim(serialize($code))) . "
			WHERE purchaseid = " . intval($purchaseid) . "
		");
		
		// Build purchase cache
		VBSHOP::build_purchases($recipient);				
	}

	/**
	* Form to purchase an item
	*/	
	public function render()
	{
		foreach ($this->registry->forumcache as $forumid => $forum)
		{
			if (in_array($forumid, $this->config['code']['excludedforums']))
			{
				// Skip this
				continue;
			}

			// Create the number option template
			$templater = vB_Template::create('option');
				$templater->register('optionvalue', 	$forumid);
				$templater->register('optiontitle', 	$forum['title']);
				$templater->register('optionselected', 	($forumid == $this->config['configuration']['forumid'] ? 'selected="selected"' : ''));
			$this->config['forumoptions'] .= $templater->render();
		}

		return parent::render();
	}	
}
?>